Subject: Re: bug#69735: [BUG] Error running any docker-composse command

From: John Kehayias <[email-masked]>
Date: Sat, 16 Mar 2024 20:37:02 +0000

Hi Edison and CC'ing Arun (commit in question),

On Mon, Mar 11, 2024 at 04:52 PM, Edison Ibáñez wrote:

> Greetings, with the last Commit, Python-Docker was updated, apparently this causes errors with Docker-Compose, the apparent solution is to update the Docker-Composse version, but changes the installation method of Python to Go, so I can't Generate the patch to update the package.
>

Indeed, we are behind with docker compose because it requires some new
effort in packaging.

> Give the error:
>
> /gnu/store/v2sr2wqfjnnlf4cr6fbaadslrlz9cdj4-python-paramiko-2.7.2/lib/python3.10/site-packages/paramiko/transport.py:219: CryptographyDeprecationWarning: Blowfish has been deprecated
>   "class": algorithms.Blowfish,
> Traceback (most recent call last):
>   File "/gnu/store/fh9sgccvjx86f168qvh7rvan3rnbydlg-docker-compose-1.29.2/bin/.docker-compose-real", line 33, in <module>
>     sys.exit(load_entry_point('docker-compose==1.29.2', 'console_scripts', 'docker-compose')())
>   File "/gnu/store/fh9sgccvjx86f168qvh7rvan3rnbydlg-docker-compose-1.29.2/lib/python3.10/site-packages/compose/cli/main.py", line 81, in main
>     command_func()
>   File "/gnu/store/fh9sgccvjx86f168qvh7rvan3rnbydlg-docker-compose-1.29.2/lib/python3.10/site-packages/compose/cli/main.py", line 200, in perform_command
>     project = project_from_options('.', options)
>   File "/gnu/store/fh9sgccvjx86f168qvh7rvan3rnbydlg-docker-compose-1.29.2/lib/python3.10/site-packages/compose/cli/command.py", line 60, in project_from_options
>     return get_project(
>   File "/gnu/store/fh9sgccvjx86f168qvh7rvan3rnbydlg-docker-compose-1.29.2/lib/python3.10/site-packages/compose/cli/command.py", line 152, in get_project
>     client = get_client(
>   File "/gnu/store/fh9sgccvjx86f168qvh7rvan3rnbydlg-docker-compose-1.29.2/lib/python3.10/site-packages/compose/cli/docker_client.py", line 41, in get_client
>     client = docker_client(
>   File "/gnu/store/fh9sgccvjx86f168qvh7rvan3rnbydlg-docker-compose-1.29.2/lib/python3.10/site-packages/compose/cli/docker_client.py", line 124, in docker_client
>     kwargs = kwargs_from_env(environment=environment, ssl_version=tls_version)
> TypeError: kwargs_from_env() got an unexpected keyword argument 'ssl_version'
>
> Thanks

I also get this error trying to use 'docker-compose'. This is because
this argument was removed in 7.0.0, see
<https://docker-py.readthedocs.io/en/stable/change-log.html>. Even more,
support for the compose v1 (which is what we are stuck I think until we
can upgrade docker/docker compose) was removed completely. A summary and
link to upstream issue: <https://stackoverflow.com/a/77651191>.

I would suggest we revert commit
d084fb4b04a1cebb59959633660013fff495cd0d and/or use the previous version
6.1.3 until we can have docker compose with v2 support. As it is, this
makes docker-compose unusable on Guix without some manual downgrade.

Arun, what do you think?

Thanks,
John